//********************************************************************************
#include	"sfr_r8m12a.h"
#include	"lcd.h"

//--------------- delay 1 ms -----------------------------------------------
void delay_msec(unsigned int ii){   // delay() 142 l
  int i;
  while(ii>0){
    	for(i=1;i<142;i++){unsigned char j; for(j=0;j<6;j++){}}
    ii--;
  }
}  
//********************************************************************************
void	lcd_cmd_4bit(char code, char flag)
{
//	union	BYTE_DATA	LCD_DATA;
	//
//	LCD_DATA.BYTE = code;
	//
	LCD_D7 = ((code & 0b00001000) != 0) ? 1 : 0;
	LCD_D6 = ((code & 0b00000100) != 0) ? 1 : 0;
	LCD_D5 = ((code & 0b00000010) != 0) ? 1 : 0;
	LCD_D4 = ((code & 0b00000001) != 0) ? 1 : 0;
//	LCD_D7 = LCD_DATA.BIT.B3;
//	LCD_D6 = LCD_DATA.BIT.B2;
//	LCD_D5 = LCD_DATA.BIT.B1;
//	LCD_D4 = LCD_DATA.BIT.B0;
	if (flag == 0) {
		LCD_RS = 1;
	} else {
		LCD_RS = 0;
	}
	delay_msec(1);
	LCD_EN = 1;;
	delay_msec(1);
	LCD_EN = 0;
}
//********************************************************************************
void	lcd_cmd_8bit(char cmd)
{
	lcd_cmd_4bit(cmd >> 4, 1);
	lcd_cmd_4bit(cmd, 1);
	if ((cmd == 0x01) || (cmd == 0x02)) {
		delay_msec(10);
	} else {
		delay_msec(1);
	}
}
//********************************************************************************
void	lcd_init()
{
	delay_msec(10);
	delay_msec(20);
	lcd_cmd_4bit(0x03, 1);
	delay_msec(5);
	lcd_cmd_4bit(0x03, 1);
	delay_msec(1);
	lcd_cmd_4bit(0x03, 1);
	delay_msec(1);
	lcd_cmd_4bit(0x02, 1);
	delay_msec(1);
	lcd_cmd_8bit(0x2C);
	lcd_cmd_8bit(0x08);
	lcd_cmd_8bit(0x0E);
	lcd_cmd_8bit(0x06);
	lcd_cmd_8bit(0x01);
}
//********************************************************************************
void	lcd_chr_cp(char out_char)
{
	lcd_cmd_4bit(out_char >> 4, 0);
	lcd_cmd_4bit(out_char, 0);
	delay_msec(1);
}
//********************************************************************************
void	lcd_chr(char row, char column, char out_char)
{
	switch (row) {
	case 1:
		lcd_cmd_8bit(0x80 + (column - 1));
		break;
	case 2:
		lcd_cmd_8bit(0xC0 + (column - 1));
		break;
	case 3:
		lcd_cmd_8bit(0x94 + (column - 1));
		break;
	case 4:
		lcd_cmd_8bit(0xD4 + (column - 1));
		break;
	}
	lcd_chr_cp(out_char);
}
//********************************************************************************
void	lcd_out_cp(char *str)
{
	while (*str != 0x00) {
		lcd_chr_cp(*str);
		str++;
	}
}
//********************************************************************************
void	lcd_out(char row, char column, char *str)
{
	switch (row) {
	case 1:
		lcd_cmd_8bit(0x80 + (column - 1));
		break;
	case 2:
		lcd_cmd_8bit(0xC0 + (column - 1));
		break;
	case 3:
		lcd_cmd_8bit(0x94 + (column - 1));
		break;
	case 4:
		lcd_cmd_8bit(0xD4 + (column - 1));
		break;
	}
	lcd_out_cp(str);
}
//**********************************************************************